From 36b0ae8f3fe5630e63ff09822c2f7bdb18064919 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 04 2020 02:49:51 +0000
Subject: [PATCH 1252/2232] Merge pull request #413 from dtolnay/sort


Emit diagnostic on cyclic structs
---

diff --git a/syntax/toposort.rs b/syntax/toposort.rs
index 62a1148..7c210f2 100644
--- a/syntax/toposort.rs
+++ b/syntax/toposort.rs
@@ -1,3 +1,4 @@
+use crate::syntax::report::Errors;
 use crate::syntax::{Api, Struct, Type, Types};
 use std::collections::btree_map::{BTreeMap as Map, Entry};
 
@@ -6,27 +7,28 @@ enum Mark {
     Visited,
 }
 
-pub fn sort<'a>(apis: &'a [Api], types: &Types<'a>) -> Vec<&'a Struct> {
+pub fn sort<'a>(cx: &mut Errors, apis: &'a [Api], types: &Types<'a>) -> Vec<&'a Struct> {
     let mut sorted = Vec::new();
     let ref mut marks = Map::new();
     for api in apis {
         if let Api::Struct(strct) = api {
-            visit(strct, &mut sorted, marks, types);
+            let _ = visit(cx, strct, &mut sorted, marks, types);
         }
     }
     sorted
 }
 
 fn visit<'a>(
+    cx: &mut Errors,
     strct: &'a Struct,
     sorted: &mut Vec<&'a Struct>,
     marks: &mut Map<*const Struct, Mark>,
     types: &Types<'a>,
-) {
+) -> Result<(), ()> {
     match marks.entry(strct) {
         Entry::Occupied(entry) => match entry.get() {
-            Mark::Visiting => panic!("not a DAG"), // FIXME
-            Mark::Visited => return,
+            Mark::Visiting => return Err(()), // not a DAG
+            Mark::Visited => return Ok(()),
         },
         Entry::Vacant(entry) => {
             entry.insert(Mark::Visiting);
@@ -35,10 +37,13 @@ fn visit<'a>(
     for field in &strct.fields {
         if let Type::Ident(ident) = &field.ty {
             if let Some(inner) = types.structs.get(&ident.rust) {
-                visit(inner, sorted, marks, types);
+                if visit(cx, inner, sorted, marks, types).is_err() {
+                    cx.error(field, "unsupported cyclic data structure");
+                }
             }
         }
     }
     marks.insert(strct, Mark::Visited);
     sorted.push(strct);
+    Ok(())
 }
diff --git a/syntax/types.rs b/syntax/types.rs
index ef2e5e6..50325d6 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -211,7 +211,7 @@ impl<'a> Types<'a> {
             toposorted_structs,
         };
 
-        types.toposorted_structs = toposort::sort(apis, &types);
+        types.toposorted_structs = toposort::sort(cx, apis, &types);
 
         let mut unresolved_structs: Vec<&Ident> = types.structs.keys().copied().collect();
         let mut new_information = true;
diff --git a/tests/ui/struct_cycle.rs b/tests/ui/struct_cycle.rs
new file mode 100644
index 0000000..be5f553
--- /dev/null
+++ b/tests/ui/struct_cycle.rs
@@ -0,0 +1,30 @@
+#[cxx::bridge]
+mod ffi {
+    struct Node0 {
+        i: i32,
+    }
+
+    struct Node1 {
+        node2: Node2,
+        vec: Vec<Node3>,
+    }
+
+    struct Node2 {
+        node4: Node4,
+    }
+
+    struct Node3 {
+        node1: Node1,
+    }
+
+    struct Node4 {
+        node0: Node0,
+        node5: Node5,
+    }
+
+    struct Node5 {
+        node2: Node2,
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/struct_cycle.stderr b/tests/ui/struct_cycle.stderr
new file mode 100644
index 0000000..7a64e29
--- /dev/null
+++ b/tests/ui/struct_cycle.stderr
@@ -0,0 +1,5 @@
+error: unsupported cyclic data structure
+  --> $DIR/struct_cycle.rs:26:9
+   |
+26 |         node2: Node2,
+   |         ^^^^^^^^^^^^

